#include<fstream>
using namespace std;
int prime(int a)
{
	if(a<2) return 0;
	int i;
	for(i=2;i*i<=a;i++)
	{
		if(a%i==0) return 0;
	}
	return 1;
}
int larg(int p,int n)
{
	int o=p;
	int u=0;
	while(o<=n)
	{
		u+=n/o;
		o*=p;
	}
	return u;
}
int main()
{
	ifstream f1("TIMK.INP");
	ofstream f2("TIMK.OUT");
	int n,m;
	f1>>n>>m;
	f1.close();
	int i;
	for(i=m;i>=2;i--)
	{
		if(prime(i)==1)
		{
			if(m%i!=0) continue;
			else
			{
				f2<<larg(i,n);
				break;
			}
		}
	}
	f2.close();
	return 0;
}
